<?php

namespace App\Services\Api;

use App\Services\FileService;
use App\Services\Traits\Pdf\BasePdfTemplate;
use Illuminate\Support\Facades\Storage;

class ChemicalsMsdsService
{
    use BasePdfTemplate;

    public function getMsds($cas, $type = null, $comInfo = null)
    {
        $fileService = app(FileService::class);
        /*$msdPdf = $fileService->getFileListByModelData($comInfo['cus_type'].'_'.$cas.'_msds', $comInfo['cus_number']);
        if($msdPdf){
           return $fileService->getDownloadUrl(current($msdPdf)['uniqueid']);
        }*/

        /*$findResult = shell_exec('find '.env('MSDS_FILE_DIR').' -iname \''.$cas.'\' -print');
        if(is_null($findResult)){
            return null;
        }*/

        $msds_html = file_get_contents(env('MSDS_FILE_DIR').'/'.$cas.'/'.$cas.'_sds_'.$type.'.html');
        if($msds_html){
            if(!is_null($comInfo)){
                $platformParams = json_decode($comInfo['platform_params'], true);
                $msds_html = preg_replace('/<dt>企业名称：<\/dt>[\s\S]*?<dd>[\s\S]*?<\/dd>/i', '<dt>企业名称：</dt> <dd>'.$platformParams['company_name'].'</dd>', $msds_html);
                $msds_html = preg_replace('/<dt>企业地址：<\/dt>[\s\S]*?<dd>[\s\S]*?<\/dd>/i', '<dt>企业地址：</dt> <dd>'.$platformParams['company_address'].'</dd>', $msds_html);
                $msds_html = preg_replace('/<dt>传真：<\/dt>[\s\S]*?<dd>[\s\S]*?<\/dd>/i', '<dt>传真：</dt> <dd>'.$platformParams['company_fax'].'</dd>', $msds_html);
                $msds_html = preg_replace('/<dt>联系电话：<\/dt>[\s\S]*?<dd>[\s\S]*?<\/dd>/i', '<dt>联系电话：</dt> <dd>'.$platformParams['company_phone'].'</dd>', $msds_html);
            }

            preg_match('/<body>[\s]*?<style>(?<bodyStyle>[\s\S]*?)<\/style>/i',$msds_html, $bodyStyle);
            $bodyStyle['bodyStyle'] = "<style>body{  font-family: 'msyh'; font-size: 0.8rem; font-weight: normal; display: block;} h2{font-size: 2.2rem; text-align: center;}.container { padding-right: 5px;padding-left: 5px;margin-right: auto;margin-left: auto;width: 98%;} .sds-cn dd p { font-weight: normal; margin-left: 20px; word-break:break-all}" .
                $bodyStyle['bodyStyle']."</style><body><div class='container'>";

            // 格式化处理
            $bodyStyle['bodyStyle'] = preg_replace('/\.sds-cn[\s]*?\{[\s]*?line-height: 1.5;[\s]*?\}/i', '.sds-cn{line-height: 2.5;}', $bodyStyle['bodyStyle']);
            $bodyStyle['bodyStyle'] = preg_replace('/\.sds-cn[\s]*?\.b-a[\s]*?\{[\s]*?border: 1px solid #000000;[\s]*?\}/i', '.sds-cn .b-a { border: 1px solid #000000; margin-left:10px;}', $bodyStyle['bodyStyle']);
            $bodyStyle['bodyStyle'] = preg_replace('/\.sds-cn[\s]*?dd.clearfix[\s]*?\{ margin-left: 20px;[\s]*?\}/i', '.sds-cn dd.clearfix { width:80% }', $bodyStyle['bodyStyle']);
            $bodyStyle['bodyStyle'] = preg_replace('/\.sds-cn[\s]*?dt[\s]*?\{[\s]*?float: left; font-weight: bold; clear: left; [\s]*?\}/i', '.sds-cn dt { float: left; font-weight: normal; clear: left; }', $bodyStyle['bodyStyle']);
            $bodyStyle['bodyStyle'] = preg_replace('/\.sds-cn[\s]*?\.list-line[\s]*?li:before[\s]*?\{ content: " —— " \}/i', '.sds-cn .list-line li:before { content: " -- " }', $bodyStyle['bodyStyle']);
            $bodyStyle['bodyStyle'] = preg_replace('/\.sds-cn[\s]*?p[\s]*?\{[\s]*?margin:[\s]*?0; \}/i', '.sds-cn p { margin: 0 15px;white-space: pre-wra }', $bodyStyle['bodyStyle']);



            $msds_html = preg_replace('/<html>/i', '<html lang="zh_CN no-js">', $msds_html);
            $msds_html = preg_replace('/<meta[\s]*?charset=[\"]UTF\-8[\"]/i', '<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
            <meta name="viewport" content="width=device-width, initial-scale=1.0, minimum-scale=1.0, maximum-scale=1.0, user-scalable=no">', $msds_html);

            //$msds_html = preg_replace('/<dd>[\s]*?/i', '<dd><p>', $msds_html);
            //$msds_html = preg_replace('/<\/dd>/i', '</p></dd>', $msds_html);

            $msds_html = preg_replace('/<body><style>(?<bodyStyle>[\s\S]*?)<\/style>/i', '@body@', $msds_html);
            $msds_html = preg_replace('/<\/body>/', '</div></body>', preg_replace('/@body@/', $bodyStyle['bodyStyle'], $msds_html));
            //$msds_html = preg_replace('/@body@/', $newMsdsHtml, $msds_html);

            if(preg_match('/<div[\s]*?class=[\\\'|\"]sds-cn-content[\\\'|\"]>(?<content>[\s\S]+?)<\/div><\/body>/i', $msds_html, $content)){
                if($content['content']){
                    preg_match_all('/(?<title>[\s\S]*?)<dl>(?<dlContent>[\s\S]*?)<\/dl>/i', $content['content'], $dlContent);
                    if($dlContent['dlContent']){
                        $newMsdsHtml = '';
                        foreach($dlContent['dlContent'] as $key => $dl){
                            $msds_html = str_replace($dlContent['title'][$key],'<h2 style="font-size: 1.6rem;font-weight: bold">'.$dlContent['title'][$key].'</h2>', $msds_html);
                            if(in_array($key, [0,5,9])){
                                $dlHtml = '';
                                if($dlContent['title'][$key]){
                                    //$dlHtml = '<h2 style="font-size: 20px; text-align: center;" align="center">'.$dlContent['title'][$key].'</h2>';
                                    preg_match_all('/<dt>(?<cTitle>[\s\S]*?)<\/dt>[\s]*?<dd[\s\S]*?>(?<cContent>[\s\S]*?)<\/dd>/i', $dl, $ddContent);
                                    if($ddContent){
                                        foreach($ddContent['cTitle'] as $k => $c){
                                            $dlHtml .= '<div><span style="margin: 0;">'.$c.'</span>';
                                            $dlHtml .= '<span style="font-weight: normal">'.$ddContent['cContent'][$k].'</span></div>';
                                        }
                                    }
                                }
                                $msds_html = str_replace($dl, $dlHtml, $msds_html);
                            }
                            if($key == 2 || $key == 4){
                                preg_match_all('/<dt>(?<cTitle>[\s\S]*?)<\/dt>[\s]*?<dd[\s\S]*?>(?<cContent>[\s\S]*?)<\/dd>/i', $dl, $ddContent);
                                if($ddContent){
                                    $dlHtml = '';
                                    foreach($ddContent['cTitle'] as $k => $c){
                                        $dlHtml .= '<div style="width:90%"><span style="margin: 0;"><b>'.$c.'</b></span>';
                                        $dlHtml .= '<span style="font-weight: normal;">'.$ddContent['cContent'][$k].'</span></div>';
                                    }
                                }
                                $msds_html = str_replace($dl, $dlHtml, $msds_html);
                            }
                        }
                    }
                    preg_match('/(?<title>第[\s]*?3[\s\S]+?)<table[\s]*?class=[\\\'|\"]table-text-center avoid-page-break-inside[\\\'|\"]>[\s\S]*?<\/table>/i', $content['content'], $tableContent);
                    if($tableContent['title']){
                        $msds_html = str_replace($tableContent['title'],'<h2 style="font-size: 1.6rem;font-weight: bold">'.$tableContent['title'].'</h2>', $msds_html);
                    }

                    preg_match('/(?<title>第4[\s\S]*?)<dl>[\s\S]*?<\/dl>/i', $content['content'], $dlContent);
                    if($dlContent['title']){
                        $msds_html = str_replace($dlContent['title'],'<h2 style="font-size: 1.6rem;font-weight: bold">'.$dlContent['title'].'</h2>', $msds_html);
                    }
                }
            }



            //file_put_contents('./test.html', $msds_html);
            //$msds_html = file_get_contents('./test.html');

            $this->getPdfApp()->loadHTML($msds_html, 'utf-8');
            //echo $htmlTemp;
            $this->getPdfApp()->render();
            $pdf = $this->getPdfApp()->output();

            if($pdf){
                $fileName = $cas.'/'.$comInfo['cus_number'].'_'.$cas.'_'.$comInfo['cus_type'].'_msds.pdf';
                $realPath = $fileService->getFileFolderPath().'/'.$fileName;
                if($fileService->saveToFile($realPath, $pdf)){
                    $fileSave = [];
                    $fileSave['uniqueid'] = $fileService->getBase64Path($realPath);
                    $fileSave['type'] = 'file';
                    $fileSave['path'] = $realPath;
                    $fileSave['name'] = str_replace('.pdf','',$fileName);
                    $fileSave['extension'] = 'pdf';
                    $fileSave['mime_type'] = 'application/pdf';
                    $fileSave['byte_size'] = '';
                    $fileSave['model_name'] = $comInfo['cus_type'].'_'.$cas.'_msds';
                    $fileSave['model_data_id'] = $comInfo['cus_number'];
                    if($fileService->saveFileRecord($fileSave)){
                        return $fileService->getDownloadUrl($fileSave['uniqueid']);
                    }
                }
            }
        }

        return null;
    }
}
